$(() => {
function getOrderDay(rowData) {
return (new Date(rowData.OrderDate)).getDay();
}
$('#card-view').dxCardView({
dataSource: orders,
keyExpr: 'OrderNumber',
cardsPerRow: 'auto',
cardMinWidth: 280,
wordWrapEnabled: true,
headerFilter: {
visible: true
},
columns: [{
dataField: 'OrderNumber',
headerFilter: {
groupInterval: 10000,
},
}, {
dataField: 'OrderDate',
dataType: 'date',
calculateFilterExpression(value, selectedFilterOperations, target) {
if (value === 'weekends') {
return [[getOrderDay, '=', 0], 'or', [getOrderDay, '=', 6]];
}
return this.defaultCalculateFilterExpression(value, selectedFilterOperations, target);
},
headerFilter: {
dataSource(data) {
data.dataSource.postProcess = function (results) {
results.push({
text: 'Weekends',
value: 'weekends',
});
return results;
};
},
},
}, {
dataField: 'SaleAmount',
dataType: 'number',
headerFilter: {
dataSource: [{
text: 'Less than $3000',
value: ['SaleAmount', '<', 3000],
}, {
text: '$3000 - $5000',
value: [['SaleAmount', '>=', 3000], ['SaleAmount', '<', 5000]],
}, {
text: '$5000 - $10000',
value: [['SaleAmount', '>=', 5000], ['SaleAmount', '<', 10000]],
}, {
text: '$10000 - $20000',
value: [['SaleAmount', '>=', 10000], ['SaleAmount', '<', 20000]],
}, {
text: 'Greater than $20000',
value: ['SaleAmount', '>=', 20000],
}],
},
}, {
dataField: 'StoreCity',
headerFilter: {
search: {
enabled: true,
editorOptions: {
placeholder: 'Search city or state',
},
searchExpr: ['StoreCity', 'StoreState'],
},
},
}, {
dataField: 'StoreState',
headerFilter: {
search: {
enabled: true,
editorOptions: {
placeholder: 'Search state or city',
},
searchExpr: ['StoreState', 'StoreCity'],
},
},
}, {
dataField: 'Employee',
}],
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" />
<script src="js/dx.all.js?v=25.1.7"></script>
<script src="data.js"></script>
<script src="index.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="card-view"></div>
</div>
</body>
</html>
const orders = [{
OrderNumber: 35703,
SaleAmount: 11800,
StoreCity: 'Los Angeles',
StoreState: 'California',
Employee: 'Harv Mudd',
OrderDate: '2014/04/10',
}, {
OrderNumber: 35711,
OrderDate: '2014/01/12',
SaleAmount: 16050,
StoreState: 'California',
StoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
OrderNumber: 35714,
OrderDate: '2014/01/22',
SaleAmount: 14750,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 35983,
OrderDate: '2014/02/07',
SaleAmount: 3725,
StoreState: 'Colorado',
StoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 36987,
OrderDate: '2014/03/11',
SaleAmount: 14200,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 38466,
OrderDate: '2014/03/01',
SaleAmount: 7800,
StoreState: 'California',
StoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
OrderNumber: 39420,
OrderDate: '2014/02/15',
SaleAmount: 20500,
StoreState: 'California',
StoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
OrderNumber: 39874,
OrderDate: '2014/02/04',
SaleAmount: 9050,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 42847,
OrderDate: '2014/02/15',
SaleAmount: 20400,
StoreState: 'Wyoming',
StoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 43982,
OrderDate: '2014/05/29',
SaleAmount: 6050,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 56272,
OrderDate: '2014/05/16',
SaleAmount: 15850,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 57429,
OrderDate: '2014/04/11',
SaleAmount: 11050,
StoreState: 'Arizona',
StoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
OrderNumber: 58292,
OrderDate: '2014/04/05',
SaleAmount: 13500,
StoreState: 'California',
StoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
OrderNumber: 62427,
OrderDate: '2014/05/17',
SaleAmount: 23500,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 65977,
OrderDate: '2014/02/13',
SaleAmount: 2550,
StoreState: 'Wyoming',
StoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 66947,
OrderDate: '2014/01/06',
SaleAmount: 3500,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 68428,
OrderDate: '2014/03/13',
SaleAmount: 10500,
StoreState: 'California',
StoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
OrderNumber: 69477,
OrderDate: '2014/01/22',
SaleAmount: 14200,
StoreState: 'California',
StoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
OrderNumber: 72947,
OrderDate: '2014/03/05',
SaleAmount: 13350,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 73088,
OrderDate: '2014/01/21',
SaleAmount: 8600,
StoreState: 'Nevada',
StoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
OrderNumber: 76927,
OrderDate: '2014/04/04',
SaleAmount: 9800,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 77297,
OrderDate: '2014/01/07',
SaleAmount: 10850,
StoreState: 'Arizona',
StoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
OrderNumber: 84744,
OrderDate: '2014/05/20',
SaleAmount: 4650,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 85028,
OrderDate: '2014/02/08',
SaleAmount: 2575,
StoreState: 'Nevada',
StoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
OrderNumber: 87297,
OrderDate: '2014/04/08',
SaleAmount: 14200,
StoreState: 'Wyoming',
StoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 88027,
OrderDate: '2014/05/18',
SaleAmount: 13650,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 94726,
OrderDate: '2014/02/23',
SaleAmount: 20500,
StoreState: 'California',
StoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
OrderNumber: 95266,
OrderDate: '2014/03/18',
SaleAmount: 9050,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 98477,
OrderDate: '2014/05/08',
SaleAmount: 23500,
StoreState: 'Wyoming',
StoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 99247,
OrderDate: '2014/02/27',
SaleAmount: 2100,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 174884,
OrderDate: '2014/03/03',
SaleAmount: 7200,
StoreState: 'Colorado',
StoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 188877,
OrderDate: '2014/02/14',
SaleAmount: 8750,
StoreState: 'Arizona',
StoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
OrderNumber: 191883,
OrderDate: '2014/02/28',
SaleAmount: 9900,
StoreState: 'California',
StoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
OrderNumber: 192474,
OrderDate: '2014/02/18',
SaleAmount: 12800,
StoreState: 'California',
StoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
OrderNumber: 193847,
OrderDate: '2014/05/06',
SaleAmount: 14100,
StoreState: 'California',
StoreCity: 'San Diego',
Employee: 'Harv Mudd',
}, {
OrderNumber: 194877,
OrderDate: '2014/03/17',
SaleAmount: 4750,
StoreState: 'California',
StoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
OrderNumber: 195746,
OrderDate: '2014/02/04',
SaleAmount: 9050,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 197474,
OrderDate: '2014/01/17',
SaleAmount: 6400,
StoreState: 'Nevada',
StoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
OrderNumber: 198746,
OrderDate: '2014/02/04',
SaleAmount: 15700,
StoreState: 'Colorado',
StoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 214222,
OrderDate: '2014/02/03',
SaleAmount: 11050,
StoreState: 'Arizona',
StoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];

<template>
<DxCardView
id="cardView"
:data-source="orders"
key-expr="OrderNumber"
cards-per-row="auto"
:card-min-width="280"
:word-wrap-enabled="true"
>
<DxHeaderFilter
:visible="true"
/>
<DxColumn
data-field="OrderNumber"
>
<DxColumnHeaderFilter
:group-interval="10000"
/>
</DxColumn>
<DxColumn
data-field="OrderDate"
data-type="date"
:calculate-filter-expression="calculateOrderDateFilterExpression"
>
<DxColumnHeaderFilter
:data-source="orderDateHeaderFilterDataSource"
/>
</DxColumn>
<DxColumn
data-field="SaleAmount"
data-type="number"
>
<DxColumnHeaderFilter
:data-source="saleAmountHeaderFilterDataSource"
/>
</DxColumn>
<DxColumn
data-field="StoreCity"
>
<DxColumnHeaderFilter>
<DxColumnHeaderFilterSearch
:enabled="true"
:editor-options="{ placeholder: 'Search city or state' }"
:search-expr="['StoreCity', 'StoreState']"
/>
</DxColumnHeaderFilter>
</DxColumn>
<DxColumn
data-field="StoreState"
>
<DxColumnHeaderFilter>
<DxColumnHeaderFilterSearch
:enabled="true"
:editor-options="{ placeholder: 'Search state or city' }"
:search-expr="['StoreState', 'StoreCity']"
/>
</DxColumnHeaderFilter>
</DxColumn>
<DxColumn
data-field="Employee"
/>
</DxCardView>
</template>
<script setup lang="ts">
import { DxCardView, DxColumn, DxHeaderFilter, DxColumnHeaderFilter, DxColumnHeaderFilterSearch, type DxCardViewTypes } from 'devextreme-vue/card-view';
import { type Order, orders } from './data.ts';
function getOrderDay(rowData: Order) {
return new Date(rowData.OrderDate).getDay();
}
function calculateOrderDateFilterExpression(
this: DxCardViewTypes.Column,
value: unknown,
selectedFilterOperations: string | null,
target: string,
) {
if (value === 'weekends') {
return [[getOrderDay, '=', 0], 'or', [getOrderDay, '=', 6]];
}
return this.defaultCalculateFilterExpression(value, selectedFilterOperations, target) as any;
}
type HeaderFilterDataSourceArg = {
dataSource: {
postProcess: (
results: Array<{ text: string; value: unknown }>,
) => Array<{ text: string; value: unknown }>;
};
};
function orderDateHeaderFilterDataSource(data: HeaderFilterDataSourceArg): void {
data.dataSource.postProcess = (results: Array<{ text: string; value: unknown }>) => {
results.push({
text: 'Weekends',
value: 'weekends',
});
return results;
};
}
const saleAmountHeaderFilterDataSource = [
{
text: 'Less than $3000',
value: ['SaleAmount', '<', 3000],
},
{
text: '$3000 - $5000',
value: [
['SaleAmount', '>=', 3000],
['SaleAmount', '<', 5000],
],
},
{
text: '$5000 - $10000',
value: [
['SaleAmount', '>=', 5000],
['SaleAmount', '<', 10000],
],
},
{
text: '$10000 - $20000',
value: [
['SaleAmount', '>=', 10000],
['SaleAmount', '<', 20000],
],
},
{
text: 'Greater than $20000',
value: ['SaleAmount', '>=', 20000],
},
];
</script>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export interface Order {
OrderNumber: number;
SaleAmount: number;
StoreCity: string;
StoreState: string;
Employee: string;
OrderDate: string;
}
export const orders: Order[] = [{
OrderNumber: 35703,
SaleAmount: 11800,
StoreCity: 'Los Angeles',
StoreState: 'California',
Employee: 'Harv Mudd',
OrderDate: '2024/04/10',
}, {
OrderNumber: 35711,
OrderDate: '2024/01/12',
SaleAmount: 16050,
StoreState: 'California',
StoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
OrderNumber: 35714,
OrderDate: '2024/01/22',
SaleAmount: 14750,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 35983,
OrderDate: '2024/02/07',
SaleAmount: 3725,
StoreState: 'Colorado',
StoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 36987,
OrderDate: '2024/03/11',
SaleAmount: 14200,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 38466,
OrderDate: '2024/03/01',
SaleAmount: 7800,
StoreState: 'California',
StoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
OrderNumber: 39420,
OrderDate: '2024/02/15',
SaleAmount: 20500,
StoreState: 'California',
StoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
OrderNumber: 39874,
OrderDate: '2024/02/04',
SaleAmount: 9050,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 42847,
OrderDate: '2024/02/15',
SaleAmount: 20400,
StoreState: 'Wyoming',
StoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 43982,
OrderDate: '2024/05/29',
SaleAmount: 6050,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 56272,
OrderDate: '2024/05/16',
SaleAmount: 15850,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 57429,
OrderDate: '2024/04/11',
SaleAmount: 11050,
StoreState: 'Arizona',
StoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
OrderNumber: 58292,
OrderDate: '2024/04/05',
SaleAmount: 13500,
StoreState: 'California',
StoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
OrderNumber: 62427,
OrderDate: '2024/05/17',
SaleAmount: 23500,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 65977,
OrderDate: '2024/02/13',
SaleAmount: 2550,
StoreState: 'Wyoming',
StoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 66947,
OrderDate: '2024/01/06',
SaleAmount: 3500,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 68428,
OrderDate: '2024/03/13',
SaleAmount: 10500,
StoreState: 'California',
StoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
OrderNumber: 69477,
OrderDate: '2024/01/22',
SaleAmount: 14200,
StoreState: 'California',
StoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
OrderNumber: 72947,
OrderDate: '2024/03/05',
SaleAmount: 13350,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 73088,
OrderDate: '2024/01/21',
SaleAmount: 8600,
StoreState: 'Nevada',
StoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
OrderNumber: 76927,
OrderDate: '2024/04/04',
SaleAmount: 9800,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 77297,
OrderDate: '2024/01/07',
SaleAmount: 10850,
StoreState: 'Arizona',
StoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
OrderNumber: 84744,
OrderDate: '2024/05/20',
SaleAmount: 4650,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 85028,
OrderDate: '2024/02/08',
SaleAmount: 2575,
StoreState: 'Nevada',
StoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
OrderNumber: 87297,
OrderDate: '2024/04/08',
SaleAmount: 14200,
StoreState: 'Wyoming',
StoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 88027,
OrderDate: '2024/05/18',
SaleAmount: 13650,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 94726,
OrderDate: '2024/02/23',
SaleAmount: 20500,
StoreState: 'California',
StoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
OrderNumber: 95266,
OrderDate: '2024/03/18',
SaleAmount: 9050,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 98477,
OrderDate: '2024/05/08',
SaleAmount: 23500,
StoreState: 'Wyoming',
StoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 99247,
OrderDate: '2024/02/27',
SaleAmount: 2100,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 174884,
OrderDate: '2024/03/03',
SaleAmount: 7200,
StoreState: 'Colorado',
StoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 188877,
OrderDate: '2024/02/14',
SaleAmount: 8750,
StoreState: 'Arizona',
StoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
OrderNumber: 191883,
OrderDate: '2024/02/28',
SaleAmount: 9900,
StoreState: 'California',
StoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
OrderNumber: 192474,
OrderDate: '2024/02/18',
SaleAmount: 12800,
StoreState: 'California',
StoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
OrderNumber: 193847,
OrderDate: '2024/05/06',
SaleAmount: 14100,
StoreState: 'California',
StoreCity: 'San Diego',
Employee: 'Harv Mudd',
}, {
OrderNumber: 194877,
OrderDate: '2024/03/17',
SaleAmount: 4750,
StoreState: 'California',
StoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
OrderNumber: 195746,
OrderDate: '2024/02/04',
SaleAmount: 9050,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 197474,
OrderDate: '2024/01/17',
SaleAmount: 6400,
StoreState: 'Nevada',
StoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
OrderNumber: 198746,
OrderDate: '2024/02/04',
SaleAmount: 15700,
StoreState: 'Colorado',
StoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 214222,
OrderDate: '2024/02/03',
SaleAmount: 11050,
StoreState: 'Arizona',
StoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app" />
</div>
</body>
</html>

<dx-card-view
id="cardView"
[dataSource]="orders"
keyExpr="OrderNumber"
cardsPerRow="auto"
[cardMinWidth]="280"
[wordWrapEnabled]="true"
>
<dxo-card-view-header-filter [visible]="true"></dxo-card-view-header-filter>
<dxi-card-view-column dataField="OrderNumber">
<dxo-card-view-column-header-filter
[groupInterval]="10000"
></dxo-card-view-column-header-filter>
</dxi-card-view-column>
<dxi-card-view-column
dataField="OrderDate"
dataType="date"
[calculateFilterExpression]="calculateOrderDateFilterExpression"
>
<dxo-card-view-column-header-filter
[dataSource]="orderDateHeaderFilterDataSource"
></dxo-card-view-column-header-filter>
</dxi-card-view-column>
<dxi-card-view-column dataField="SaleAmount" dataType="number">
<dxo-card-view-column-header-filter
[dataSource]="saleAmountHeaderFilterDataSource"
></dxo-card-view-column-header-filter>
</dxi-card-view-column>
<dxi-card-view-column dataField="StoreCity">
<dxo-card-view-column-header-filter>
<dxo-card-view-column-header-filter-search
[enabled]="true"
[editorOptions]="{ placeholder: 'Search city or state' }"
[searchExpr]="['StoreCity', 'StoreState']"
></dxo-card-view-column-header-filter-search>
</dxo-card-view-column-header-filter>
</dxi-card-view-column>
<dxi-card-view-column dataField="StoreState">
<dxo-card-view-column-header-filter>
<dxo-card-view-column-header-filter-search
[enabled]="true"
[editorOptions]="{ placeholder: 'Search state or city' }"
[searchExpr]="['StoreState', 'StoreCity']"
></dxo-card-view-column-header-filter-search>
</dxo-card-view-column-header-filter>
</dxi-card-view-column>
<dxi-card-view-column dataField="Employee"></dxi-card-view-column>
</dx-card-view>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxCardViewModule, DxCardViewTypes } from 'devextreme-angular/ui/card-view';
import { Order, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
function getOrderDay(rowData: Order) {
return new Date(rowData.OrderDate).getDay();
}
@Component({
styleUrls: [`app/app.component.css`],
selector: 'demo-app',
templateUrl: `app/app.component.html`,
providers: [Service],
imports: [
DxCardViewModule,
],
})
export class AppComponent {
orderDateHeaderFilterDataSource(data) {
data.dataSource.postProcess = (results) => {
results.push({
text: 'Weekends',
value: 'weekends',
});
return results;
};
}
saleAmountHeaderFilterDataSource = [
{
text: 'Less than $3000',
value: ['SaleAmount', '<', 3000],
},
{
text: '$3000 - $5000',
value: [
['SaleAmount', '>=', 3000],
['SaleAmount', '<', 5000],
],
},
{
text: '$5000 - $10000',
value: [
['SaleAmount', '>=', 5000],
['SaleAmount', '<', 10000],
],
},
{
text: '$10000 - $20000',
value: [
['SaleAmount', '>=', 10000],
['SaleAmount', '<', 20000],
],
},
{
text: 'Greater than $20000',
value: ['SaleAmount', '>=', 20000],
},
];
calculateOrderDateFilterExpression(this: DxCardViewTypes.Column, value, selectedFilterOperations, target) {
if (value === 'weekends') {
return [[getOrderDay, '=', 0], 'or', [getOrderDay, '=', 6]];
}
return this.defaultCalculateFilterExpression(value, selectedFilterOperations, target);
}
orders: Order[];
constructor(service: Service) {
this.orders = service.getOrders();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
import { Injectable } from '@angular/core';
export interface Order {
OrderNumber: number;
SaleAmount: number;
StoreCity: string;
StoreState: string;
Employee: string;
OrderDate: string;
}
const orders: Order[] = [{
OrderNumber: 35703,
SaleAmount: 11800,
StoreCity: 'Los Angeles',
StoreState: 'California',
Employee: 'Harv Mudd',
OrderDate: '2024/04/10',
}, {
OrderNumber: 35711,
OrderDate: '2024/01/12',
SaleAmount: 16050,
StoreState: 'California',
StoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
OrderNumber: 35714,
OrderDate: '2024/01/22',
SaleAmount: 14750,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 35983,
OrderDate: '2024/02/07',
SaleAmount: 3725,
StoreState: 'Colorado',
StoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 36987,
OrderDate: '2024/03/11',
SaleAmount: 14200,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 38466,
OrderDate: '2024/03/01',
SaleAmount: 7800,
StoreState: 'California',
StoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
OrderNumber: 39420,
OrderDate: '2024/02/15',
SaleAmount: 20500,
StoreState: 'California',
StoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
OrderNumber: 39874,
OrderDate: '2024/02/04',
SaleAmount: 9050,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 42847,
OrderDate: '2024/02/15',
SaleAmount: 20400,
StoreState: 'Wyoming',
StoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 43982,
OrderDate: '2024/05/29',
SaleAmount: 6050,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 56272,
OrderDate: '2024/05/16',
SaleAmount: 15850,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 57429,
OrderDate: '2024/04/11',
SaleAmount: 11050,
StoreState: 'Arizona',
StoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
OrderNumber: 58292,
OrderDate: '2024/04/05',
SaleAmount: 13500,
StoreState: 'California',
StoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
OrderNumber: 62427,
OrderDate: '2024/05/17',
SaleAmount: 23500,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 65977,
OrderDate: '2024/02/13',
SaleAmount: 2550,
StoreState: 'Wyoming',
StoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 66947,
OrderDate: '2024/01/06',
SaleAmount: 3500,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 68428,
OrderDate: '2024/03/13',
SaleAmount: 10500,
StoreState: 'California',
StoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
OrderNumber: 69477,
OrderDate: '2024/01/22',
SaleAmount: 14200,
StoreState: 'California',
StoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
OrderNumber: 72947,
OrderDate: '2024/03/05',
SaleAmount: 13350,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 73088,
OrderDate: '2024/01/21',
SaleAmount: 8600,
StoreState: 'Nevada',
StoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
OrderNumber: 76927,
OrderDate: '2024/04/04',
SaleAmount: 9800,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 77297,
OrderDate: '2024/01/07',
SaleAmount: 10850,
StoreState: 'Arizona',
StoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
OrderNumber: 84744,
OrderDate: '2024/05/20',
SaleAmount: 4650,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 85028,
OrderDate: '2024/02/08',
SaleAmount: 2575,
StoreState: 'Nevada',
StoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
OrderNumber: 87297,
OrderDate: '2024/04/08',
SaleAmount: 14200,
StoreState: 'Wyoming',
StoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 88027,
OrderDate: '2024/05/18',
SaleAmount: 13650,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 94726,
OrderDate: '2024/02/23',
SaleAmount: 20500,
StoreState: 'California',
StoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
OrderNumber: 95266,
OrderDate: '2024/03/18',
SaleAmount: 9050,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 98477,
OrderDate: '2024/05/08',
SaleAmount: 23500,
StoreState: 'Wyoming',
StoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 99247,
OrderDate: '2024/02/27',
SaleAmount: 2100,
StoreState: 'Utah',
StoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
OrderNumber: 174884,
OrderDate: '2024/03/03',
SaleAmount: 7200,
StoreState: 'Colorado',
StoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 188877,
OrderDate: '2024/02/14',
SaleAmount: 8750,
StoreState: 'Arizona',
StoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}, {
OrderNumber: 191883,
OrderDate: '2024/02/28',
SaleAmount: 9900,
StoreState: 'California',
StoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
OrderNumber: 192474,
OrderDate: '2024/02/18',
SaleAmount: 12800,
StoreState: 'California',
StoreCity: 'Anaheim',
Employee: 'Harv Mudd',
}, {
OrderNumber: 193847,
OrderDate: '2024/05/06',
SaleAmount: 14100,
StoreState: 'California',
StoreCity: 'San Diego',
Employee: 'Harv Mudd',
}, {
OrderNumber: 194877,
OrderDate: '2024/03/17',
SaleAmount: 4750,
StoreState: 'California',
StoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
OrderNumber: 195746,
OrderDate: '2024/02/04',
SaleAmount: 9050,
StoreState: 'Nevada',
StoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
OrderNumber: 197474,
OrderDate: '2024/01/17',
SaleAmount: 6400,
StoreState: 'Nevada',
StoreCity: 'Reno',
Employee: 'Clark Morgan',
}, {
OrderNumber: 198746,
OrderDate: '2024/02/04',
SaleAmount: 15700,
StoreState: 'Colorado',
StoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
OrderNumber: 214222,
OrderDate: '2024/02/03',
SaleAmount: 11050,
StoreState: 'Arizona',
StoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
@Injectable()
export class Service {
getOrders() {
return orders;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React Card View - Column Header Filter

DevExtreme CardView includes a header used to filter cards by field values. Click the filter icon in the field's header panel to open the pop-up CardView filter.

Backend API
import React, { type ComponentProps } from 'react'; import CardView, { Column, HeaderFilter, ColumnHeaderFilter, ColumnHeaderFilterSearch } from 'devextreme-react/card-view'; import type { CardViewTypes } from 'devextreme-react/card-view'; import type { DataSourceOptions } from 'devextreme-react/common/data'; import { orders } from './data.ts'; import type { Order, OrderFilter } from './data.ts'; function getOrderDay(rowData: Order) { return new Date(rowData.OrderDate).getDay(); } function calculateOrderDateFilterExpression( this: CardViewTypes.Column, value: string, selectedFilterOperations: string | null, target: string ) { if (value === 'weekends') { return [[getOrderDay, '=', 0], 'or', [getOrderDay, '=', 6]]; } return this.defaultCalculateFilterExpression(value, selectedFilterOperations, target); } const saleAmountHeaderFilterDataSource: OrderFilter[] = [ { text: 'Less than $3000', value: ['SaleAmount', '<', 3000], }, { text: '$3000 - $5000', value: [ ['SaleAmount', '>=', 3000], ['SaleAmount', '<', 5000], ], }, { text: '$5000 - $10000', value: [ ['SaleAmount', '>=', 5000], ['SaleAmount', '<', 10000], ], }, { text: '$10000 - $20000', value: [ ['SaleAmount', '>=', 10000], ['SaleAmount', '<', 20000], ], }, { text: 'Greater than $20000', value: ['SaleAmount', '>=', 20000], }, ]; interface HeaderFilterDataResult { text: string; value: string; } interface HeaderFilterDataSourceOptions { component: Record<string, any>; dataSource: DataSourceOptions<HeaderFilterDataResult> | null; } function orderDateHeaderFilterDataSource(options: HeaderFilterDataSourceOptions): void { if (options.dataSource) { options.dataSource.postProcess = (results: HeaderFilterDataResult[]) => { results.push({ text: 'Weekends', value: 'weekends', }); return results; }; } } const App = () => ( <CardView dataSource={orders} keyExpr="OrderNumber" cardsPerRow="auto" cardMinWidth={280} wordWrapEnabled={true} > <HeaderFilter visible={true} /> <Column dataField="OrderNumber" > <ColumnHeaderFilter groupInterval={10000} /> </Column> <Column dataField="OrderDate" dataType="date" calculateFilterExpression={calculateOrderDateFilterExpression as ComponentProps<typeof Column>['calculateFilterExpression']} > <ColumnHeaderFilter dataSource={orderDateHeaderFilterDataSource} /> </Column> <Column dataField="SaleAmount" dataType="number" > <ColumnHeaderFilter dataSource={saleAmountHeaderFilterDataSource} /> </Column> <Column dataField="StoreCity" > <ColumnHeaderFilter> <ColumnHeaderFilterSearch enabled={true} editorOptions={{ placeholder: 'Search city or state', }} searchExpr={['StoreCity', 'StoreState']} /> </ColumnHeaderFilter> </Column> <Column dataField="StoreState" > <ColumnHeaderFilter> <ColumnHeaderFilterSearch enabled={true} editorOptions={{ placeholder: 'Search state or city', }} searchExpr={['StoreState', 'StoreCity']} /> </ColumnHeaderFilter> </Column> <Column dataField="Employee" /> </CardView> ); export default App;
import React from 'react'; import CardView, { Column, HeaderFilter, ColumnHeaderFilter, ColumnHeaderFilterSearch, } from 'devextreme-react/card-view'; import { orders } from './data.js'; function getOrderDay(rowData) { return new Date(rowData.OrderDate).getDay(); } function calculateOrderDateFilterExpression(value, selectedFilterOperations, target) { if (value === 'weekends') { return [[getOrderDay, '=', 0], 'or', [getOrderDay, '=', 6]]; } return this.defaultCalculateFilterExpression(value, selectedFilterOperations, target); } const saleAmountHeaderFilterDataSource = [ { text: 'Less than $3000', value: ['SaleAmount', '<', 3000], }, { text: '$3000 - $5000', value: [ ['SaleAmount', '>=', 3000], ['SaleAmount', '<', 5000], ], }, { text: '$5000 - $10000', value: [ ['SaleAmount', '>=', 5000], ['SaleAmount', '<', 10000], ], }, { text: '$10000 - $20000', value: [ ['SaleAmount', '>=', 10000], ['SaleAmount', '<', 20000], ], }, { text: 'Greater than $20000', value: ['SaleAmount', '>=', 20000], }, ]; function orderDateHeaderFilterDataSource(options) { if (options.dataSource) { options.dataSource.postProcess = (results) => { results.push({ text: 'Weekends', value: 'weekends', }); return results; }; } } const App = () => ( <CardView dataSource={orders} keyExpr="OrderNumber" cardsPerRow="auto" cardMinWidth={280} wordWrapEnabled={true} > <HeaderFilter visible={true} /> <Column dataField="OrderNumber"> <ColumnHeaderFilter groupInterval={10000} /> </Column> <Column dataField="OrderDate" dataType="date" calculateFilterExpression={calculateOrderDateFilterExpression} > <ColumnHeaderFilter dataSource={orderDateHeaderFilterDataSource} /> </Column> <Column dataField="SaleAmount" dataType="number" > <ColumnHeaderFilter dataSource={saleAmountHeaderFilterDataSource} /> </Column> <Column dataField="StoreCity"> <ColumnHeaderFilter> <ColumnHeaderFilterSearch enabled={true} editorOptions={{ placeholder: 'Search city or state', }} searchExpr={['StoreCity', 'StoreState']} /> </ColumnHeaderFilter> </Column> <Column dataField="StoreState"> <ColumnHeaderFilter> <ColumnHeaderFilterSearch enabled={true} editorOptions={{ placeholder: 'Search state or city', }} searchExpr={['StoreState', 'StoreCity']} /> </ColumnHeaderFilter> </Column> <Column dataField="Employee" /> </CardView> ); export default App;
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
import type { FilterBuilderTypes } from 'devextreme-react/filter-builder'; export interface Order { OrderNumber: number; SaleAmount: number; StoreCity: string; StoreState: string; Employee: string; OrderDate: string; } export type OrderFilterValue<T extends keyof Order = keyof Order> = [T, FilterBuilderTypes.FilterOperation, Order[T]]; export interface OrderFilter { text: string; value: OrderFilterValue | OrderFilterValue[]; } export const orders: Order[] = [{ OrderNumber: 35703, SaleAmount: 11800, StoreCity: 'Los Angeles', StoreState: 'California', Employee: 'Harv Mudd', OrderDate: '2014/04/10', }, { OrderNumber: 35711, OrderDate: '2014/01/12', SaleAmount: 16050, StoreState: 'California', StoreCity: 'San Jose', Employee: 'Jim Packard', }, { OrderNumber: 35714, OrderDate: '2014/01/22', SaleAmount: 14750, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 35983, OrderDate: '2014/02/07', SaleAmount: 3725, StoreState: 'Colorado', StoreCity: 'Denver', Employee: 'Todd Hoffman', }, { OrderNumber: 36987, OrderDate: '2014/03/11', SaleAmount: 14200, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 38466, OrderDate: '2014/03/01', SaleAmount: 7800, StoreState: 'California', StoreCity: 'Los Angeles', Employee: 'Harv Mudd', }, { OrderNumber: 39420, OrderDate: '2014/02/15', SaleAmount: 20500, StoreState: 'California', StoreCity: 'San Jose', Employee: 'Jim Packard', }, { OrderNumber: 39874, OrderDate: '2014/02/04', SaleAmount: 9050, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 42847, OrderDate: '2014/02/15', SaleAmount: 20400, StoreState: 'Wyoming', StoreCity: 'Casper', Employee: 'Todd Hoffman', }, { OrderNumber: 43982, OrderDate: '2014/05/29', SaleAmount: 6050, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 56272, OrderDate: '2014/05/16', SaleAmount: 15850, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 57429, OrderDate: '2014/04/11', SaleAmount: 11050, StoreState: 'Arizona', StoreCity: 'Phoenix', Employee: 'Clark Morgan', }, { OrderNumber: 58292, OrderDate: '2014/04/05', SaleAmount: 13500, StoreState: 'California', StoreCity: 'Los Angeles', Employee: 'Harv Mudd', }, { OrderNumber: 62427, OrderDate: '2014/05/17', SaleAmount: 23500, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 65977, OrderDate: '2014/02/13', SaleAmount: 2550, StoreState: 'Wyoming', StoreCity: 'Casper', Employee: 'Todd Hoffman', }, { OrderNumber: 66947, OrderDate: '2014/01/06', SaleAmount: 3500, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 68428, OrderDate: '2014/03/13', SaleAmount: 10500, StoreState: 'California', StoreCity: 'Los Angeles', Employee: 'Harv Mudd', }, { OrderNumber: 69477, OrderDate: '2014/01/22', SaleAmount: 14200, StoreState: 'California', StoreCity: 'Anaheim', Employee: 'Harv Mudd', }, { OrderNumber: 72947, OrderDate: '2014/03/05', SaleAmount: 13350, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 73088, OrderDate: '2014/01/21', SaleAmount: 8600, StoreState: 'Nevada', StoreCity: 'Reno', Employee: 'Clark Morgan', }, { OrderNumber: 76927, OrderDate: '2014/04/04', SaleAmount: 9800, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 77297, OrderDate: '2014/01/07', SaleAmount: 10850, StoreState: 'Arizona', StoreCity: 'Phoenix', Employee: 'Clark Morgan', }, { OrderNumber: 84744, OrderDate: '2014/05/20', SaleAmount: 4650, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 85028, OrderDate: '2014/02/08', SaleAmount: 2575, StoreState: 'Nevada', StoreCity: 'Reno', Employee: 'Clark Morgan', }, { OrderNumber: 87297, OrderDate: '2014/04/08', SaleAmount: 14200, StoreState: 'Wyoming', StoreCity: 'Casper', Employee: 'Todd Hoffman', }, { OrderNumber: 88027, OrderDate: '2014/05/18', SaleAmount: 13650, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 94726, OrderDate: '2014/02/23', SaleAmount: 20500, StoreState: 'California', StoreCity: 'San Jose', Employee: 'Jim Packard', }, { OrderNumber: 95266, OrderDate: '2014/03/18', SaleAmount: 9050, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 98477, OrderDate: '2014/05/08', SaleAmount: 23500, StoreState: 'Wyoming', StoreCity: 'Casper', Employee: 'Todd Hoffman', }, { OrderNumber: 99247, OrderDate: '2014/02/27', SaleAmount: 2100, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 174884, OrderDate: '2014/03/03', SaleAmount: 7200, StoreState: 'Colorado', StoreCity: 'Denver', Employee: 'Todd Hoffman', }, { OrderNumber: 188877, OrderDate: '2014/02/14', SaleAmount: 8750, StoreState: 'Arizona', StoreCity: 'Phoenix', Employee: 'Clark Morgan', }, { OrderNumber: 191883, OrderDate: '2014/02/28', SaleAmount: 9900, StoreState: 'California', StoreCity: 'Los Angeles', Employee: 'Harv Mudd', }, { OrderNumber: 192474, OrderDate: '2014/02/18', SaleAmount: 12800, StoreState: 'California', StoreCity: 'Anaheim', Employee: 'Harv Mudd', }, { OrderNumber: 193847, OrderDate: '2014/05/06', SaleAmount: 14100, StoreState: 'California', StoreCity: 'San Diego', Employee: 'Harv Mudd', }, { OrderNumber: 194877, OrderDate: '2014/03/17', SaleAmount: 4750, StoreState: 'California', StoreCity: 'San Jose', Employee: 'Jim Packard', }, { OrderNumber: 195746, OrderDate: '2014/02/04', SaleAmount: 9050, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 197474, OrderDate: '2014/01/17', SaleAmount: 6400, StoreState: 'Nevada', StoreCity: 'Reno', Employee: 'Clark Morgan', }, { OrderNumber: 198746, OrderDate: '2014/02/04', SaleAmount: 15700, StoreState: 'Colorado', StoreCity: 'Denver', Employee: 'Todd Hoffman', }, { OrderNumber: 214222, OrderDate: '2014/02/03', SaleAmount: 11050, StoreState: 'Arizona', StoreCity: 'Phoenix', Employee: 'Clark Morgan', }];
window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, jsx: 'react', }, meta: { 'react': { 'esModule': true, }, 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, defaultExtension: 'js', map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme-react/common': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
export const orders = [ { OrderNumber: 35703, SaleAmount: 11800, StoreCity: 'Los Angeles', StoreState: 'California', Employee: 'Harv Mudd', OrderDate: '2014/04/10', }, { OrderNumber: 35711, OrderDate: '2014/01/12', SaleAmount: 16050, StoreState: 'California', StoreCity: 'San Jose', Employee: 'Jim Packard', }, { OrderNumber: 35714, OrderDate: '2014/01/22', SaleAmount: 14750, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 35983, OrderDate: '2014/02/07', SaleAmount: 3725, StoreState: 'Colorado', StoreCity: 'Denver', Employee: 'Todd Hoffman', }, { OrderNumber: 36987, OrderDate: '2014/03/11', SaleAmount: 14200, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 38466, OrderDate: '2014/03/01', SaleAmount: 7800, StoreState: 'California', StoreCity: 'Los Angeles', Employee: 'Harv Mudd', }, { OrderNumber: 39420, OrderDate: '2014/02/15', SaleAmount: 20500, StoreState: 'California', StoreCity: 'San Jose', Employee: 'Jim Packard', }, { OrderNumber: 39874, OrderDate: '2014/02/04', SaleAmount: 9050, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 42847, OrderDate: '2014/02/15', SaleAmount: 20400, StoreState: 'Wyoming', StoreCity: 'Casper', Employee: 'Todd Hoffman', }, { OrderNumber: 43982, OrderDate: '2014/05/29', SaleAmount: 6050, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 56272, OrderDate: '2014/05/16', SaleAmount: 15850, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 57429, OrderDate: '2014/04/11', SaleAmount: 11050, StoreState: 'Arizona', StoreCity: 'Phoenix', Employee: 'Clark Morgan', }, { OrderNumber: 58292, OrderDate: '2014/04/05', SaleAmount: 13500, StoreState: 'California', StoreCity: 'Los Angeles', Employee: 'Harv Mudd', }, { OrderNumber: 62427, OrderDate: '2014/05/17', SaleAmount: 23500, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 65977, OrderDate: '2014/02/13', SaleAmount: 2550, StoreState: 'Wyoming', StoreCity: 'Casper', Employee: 'Todd Hoffman', }, { OrderNumber: 66947, OrderDate: '2014/01/06', SaleAmount: 3500, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 68428, OrderDate: '2014/03/13', SaleAmount: 10500, StoreState: 'California', StoreCity: 'Los Angeles', Employee: 'Harv Mudd', }, { OrderNumber: 69477, OrderDate: '2014/01/22', SaleAmount: 14200, StoreState: 'California', StoreCity: 'Anaheim', Employee: 'Harv Mudd', }, { OrderNumber: 72947, OrderDate: '2014/03/05', SaleAmount: 13350, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 73088, OrderDate: '2014/01/21', SaleAmount: 8600, StoreState: 'Nevada', StoreCity: 'Reno', Employee: 'Clark Morgan', }, { OrderNumber: 76927, OrderDate: '2014/04/04', SaleAmount: 9800, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 77297, OrderDate: '2014/01/07', SaleAmount: 10850, StoreState: 'Arizona', StoreCity: 'Phoenix', Employee: 'Clark Morgan', }, { OrderNumber: 84744, OrderDate: '2014/05/20', SaleAmount: 4650, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 85028, OrderDate: '2014/02/08', SaleAmount: 2575, StoreState: 'Nevada', StoreCity: 'Reno', Employee: 'Clark Morgan', }, { OrderNumber: 87297, OrderDate: '2014/04/08', SaleAmount: 14200, StoreState: 'Wyoming', StoreCity: 'Casper', Employee: 'Todd Hoffman', }, { OrderNumber: 88027, OrderDate: '2014/05/18', SaleAmount: 13650, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 94726, OrderDate: '2014/02/23', SaleAmount: 20500, StoreState: 'California', StoreCity: 'San Jose', Employee: 'Jim Packard', }, { OrderNumber: 95266, OrderDate: '2014/03/18', SaleAmount: 9050, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 98477, OrderDate: '2014/05/08', SaleAmount: 23500, StoreState: 'Wyoming', StoreCity: 'Casper', Employee: 'Todd Hoffman', }, { OrderNumber: 99247, OrderDate: '2014/02/27', SaleAmount: 2100, StoreState: 'Utah', StoreCity: 'Salt Lake City', Employee: 'Clark Morgan', }, { OrderNumber: 174884, OrderDate: '2014/03/03', SaleAmount: 7200, StoreState: 'Colorado', StoreCity: 'Denver', Employee: 'Todd Hoffman', }, { OrderNumber: 188877, OrderDate: '2014/02/14', SaleAmount: 8750, StoreState: 'Arizona', StoreCity: 'Phoenix', Employee: 'Clark Morgan', }, { OrderNumber: 191883, OrderDate: '2014/02/28', SaleAmount: 9900, StoreState: 'California', StoreCity: 'Los Angeles', Employee: 'Harv Mudd', }, { OrderNumber: 192474, OrderDate: '2014/02/18', SaleAmount: 12800, StoreState: 'California', StoreCity: 'Anaheim', Employee: 'Harv Mudd', }, { OrderNumber: 193847, OrderDate: '2014/05/06', SaleAmount: 14100, StoreState: 'California', StoreCity: 'San Diego', Employee: 'Harv Mudd', }, { OrderNumber: 194877, OrderDate: '2014/03/17', SaleAmount: 4750, StoreState: 'California', StoreCity: 'San Jose', Employee: 'Jim Packard', }, { OrderNumber: 195746, OrderDate: '2014/02/04', SaleAmount: 9050, StoreState: 'Nevada', StoreCity: 'Las Vegas', Employee: 'Harv Mudd', }, { OrderNumber: 197474, OrderDate: '2014/01/17', SaleAmount: 6400, StoreState: 'Nevada', StoreCity: 'Reno', Employee: 'Clark Morgan', }, { OrderNumber: 198746, OrderDate: '2014/02/04', SaleAmount: 15700, StoreState: 'Colorado', StoreCity: 'Denver', Employee: 'Todd Hoffman', }, { OrderNumber: 214222, OrderDate: '2014/02/03', SaleAmount: 11050, StoreState: 'Arizona', StoreCity: 'Phoenix', Employee: 'Clark Morgan', }, ];
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> <link rel="stylesheet" type="text/css" href="styles.css" /> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>

Display Header Filter Icons

Assign true to the headerFilter.visible property to allow users to filter CardView fields with header icons. To hide the icon for a specific column, set columns.allowHeaderFiltering to false.

Enable Search UI Within Header Filters

DevExtreme CardView supports text-based search (to find specific values in a header filter). Define the search property in the headerFilter object or a columns.headerFilter object to configure this capability.

The search panel checks for values only within the same data field. To expand search to additional fields, use the search.searchExpr property. For example, this demo allows you to enter a state name in the City column's header filter. You can then see a list of all cities within the specified state and select city names that you want to use as a filter.

To apply a comparison operation (used to search header filter values), specify the search.mode property.